# Copyright (C) 2022. Logiciel élaboré par l'État, via la Drees.
# Nom des auteur.e.s : Julie Kamionka et Maxime Bergeat, Drees.
# Ce programme informatique a été développé par la Drees.
# Il permet de produire les statistiques présentes dans l'Études et Résultats 1249, intitulé « Sept téléconsultations de médecine générale sur dix concernent des patients des grands pôles urbains en 2021 », décembre 2022.
# Ce programme a été exécuté en décembre 2022 avec la version 4.1.2 de R et les paquets data.table_1.14.2, dplyr_1.0.7, dbplyr_2.1.1 et ROracle_1.3-1.  
# La publication peut être consultée sur le site de la DREES : https://drees.solidarites-sante.gouv.fr/sites/default/files/2022-12/ER1249.pdf
# Bien qu'il n'existe aucune obligation légale à ce sujet, les utilisateurs de ce programme sont invités à signaler à la DREES leurs travaux issus de la réutilisation de ce code, ainsi que les éventuels problèmes ou anomalies qu'ils y rencontreraient, en écrivant à DREES-CODE@sante.gouv.fr
# Ce logiciel est régi par la licence EUPL V1.2 soumise au droit français et européen, respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence EUPL V1.2, telle que diffusée sur https://eupl.eu/1.2/fr/ et reproduite dans le fichier LICENCE diffusé conjointement au présent programme. 
# En contrepartie de l'accessibilité au code source et des droits de copie, de modification et de redistribution accordés par cette licence, il n'est offert aux utilisateurs qu'une garantie limitée. Pour les mêmes raisons, seule une responsabilité restreinte pèse sur l'auteur du programme, le titulaire des droits patrimoniaux et les concédants successifs.

# Cette fonction sert à la constitution et la correction du code commune du cabinet du médecin.

code_commune_medecin <- function(ps){
  
  #### Constitution du code commune ####
  print("Constitution du code commune")
  
  ps[,PFS_COD_POS := as.character(PFS_COD_POS)] # code postal
  ps[,PFS_EXC_COM := as.character(PFS_EXC_COM)] # code commune
  
  # Département du cabinet (récupéré à partir du code postal)
  print("Département")
  
  # Code postal sur 5 caractères 
  ps[nchar(PFS_COD_POS) == 4,PFS_COD_POS := paste0("0",PFS_COD_POS)]
  
  ## Hors Corse et DROM
  ps[!substr(PFS_COD_POS,1,2)%in%c("20","97"),dep := substr(PFS_COD_POS,1,2)]
  
  ## Corse
  ps[substr(PFS_COD_POS,1,3) %in% c("200","201"),dep := "2A"]
  ps[substr(PFS_COD_POS,1,3) %in% c("202","206"),dep := "2B"]
  
  ## DROM
  ps[substr(PFS_COD_POS,1,2) == "97",dep := substr(PFS_COD_POS,1,3)]
  
  # Code commune sur 3 caractères
  print("Commune")
  
  ps[nchar(PFS_EXC_COM) == 1,PFS_EXC_COM := paste0("00",PFS_EXC_COM)]
  ps[nchar(PFS_EXC_COM) == 2,PFS_EXC_COM := paste0("0",PFS_EXC_COM)]
  
  # Concaténation du code département et du code commune
  
  ## Hors DROM
  ps[substr(dep,1,2)!="97",depcom := paste0(dep,PFS_EXC_COM)]
  
  ## DROM
  ps[substr(dep,1,2)=="97",depcom := paste0(dep,substr(PFS_EXC_COM,2,3))]
  
  # Codes communes dans les communes 2022
  print(paste0("Codes communes corrects : ",nrow(ps[depcom%in%communes2022$depcom,])," lignes"))
  # Codes communes hors communes 2022
  print(paste0("Codes communes incorrects : ",nrow(ps[!depcom%in%communes2022$depcom,])," lignes"))
  
  #### Correction du code commune (reprise macro prod APL) ####
  print("Correction du code commune")
  
  ps$PFS_LIB_COM <- gsub(" ","",ps$PFS_LIB_COM)
  setnames(ps,c("PFS_LIB_COM","PFS_COD_POS"),
           c("libcom","codepost"))
  ps[,libcom := toupper(libcom)]
  ps[, c("depcom_init", "libcom_init") := .(depcom, libcom)]
  
  # Traitement des mauvais codes DROM
  print("Correction des codes DROM")
  
  ps$depcom <- ifelse(substr(ps$depcom_init, 1, 2) == "9A",
                      paste0("971", substr(ps$depcom_init, 4, 5)),
                      as.character(ps$depcom)
  )
  ps$depcom <- ifelse(substr(ps$depcom_init, 1, 2) == "9B",
                      paste0("972", substr(ps$depcom_init, 4, 5)),
                      as.character(ps$depcom)
  )
  ps$depcom <- ifelse(substr(ps$depcom_init, 1, 2) == "9C",
                      paste0("973", substr(ps$depcom_init, 4, 5)),
                      as.character(ps$depcom)
  )
  ps$depcom <- ifelse(substr(ps$depcom_init, 1, 2) == "9D",
                      paste0("974", substr(ps$depcom_init, 4, 5)),
                      as.character(ps$depcom)
  )
  ps$depcom <- ifelse(substr(ps$depcom_init, 1, 2) == "9E",
                      paste0("976", substr(ps$depcom_init, 4, 5)),
                      as.character(ps$depcom)
  )
  
  ps$depcom_init <- ps$depcom
  
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom,])," lignes"))
  
  ##### Corrections manuelles #####
  print("Corrections manuelles")
  
  # Corrections manuelles des codes communes des cabinets des PS (issues de la prod APL) 
  
  # Corrections de l'ancienne macro SAS
  
  ps$depcom <- ifelse(ps$depcom_init == "64273" & toupper(ps$libcom_init) %in% c("ST MARTIN DE SEIGNANX", "SAINT-MARTIN-DE-SEIGNANX"),
                      "40273", as.character(ps$depcom)
  )
  
  ps$depcom <- ifelse(ps$depcom_init == "64312",
                      "40312", as.character(ps$depcom)
  ) # 64312-->40312
  
  ps$depcom <- ifelse(ps$depcom_init == "64209",
                      "40209",as.character(ps$depcom)
  ) # 64209-->40209
  
  ps$depcom <- ifelse(ps$depcom_init == "64248",
                      "40248",as.character(ps$depcom)
  ) # 64248-->40248
  
  ps$depcom <- ifelse(ps$depcom_init == "06907" & toupper(ps$libcom_init) %in% c("GRASSE", ""),
                      "06069",as.character(ps$depcom)
  ) # GRASSE : 06907-->06069
  
  ps$depcom <- ifelse(ps$depcom_init == "06920" & toupper(ps$libcom_init) %in% c("CANNES LA BOCCA", ""),
                      "06029",as.character(ps$depcom)
  ) # CANNES LA BOCCA : 06920-->06029
  
  ps$depcom <- ifelse(ps$depcom_init == "06922" & toupper(ps$libcom_init) %in% c("CAGNES SUR MER", ""),
                      "06027", as.character(ps$depcom)
  ) # CAGNES SUR MER : 06922-->06027
  
  ps$depcom <- ifelse(ps$depcom_init == "06923" & toupper(ps$libcom_init) %in% c("GOLFE JUAN", "LE GOLFE JUAN", ""),
                      "06155", as.character(ps$depcom)
  ) # LE GOLFE JUAN : 06923-->06155
  
  ps$depcom <- ifelse(ps$depcom_init == "06924" & toupper(ps$libcom_init) %in% c("JUAN LES PINS", ""),
                      "06004",as.character(ps$depcom)
  ) # JUAN LES PINS : 06924-->06004
  
  ps$depcom <- ifelse(ps$depcom_init == "06964" & toupper(ps$libcom_init) %in% c("JUAN LES PINS", ""),
                      "06004", as.character(ps$depcom)
  ) # JUAN LES PINS : 06964-->06004
  
  ps$depcom <- ifelse(ps$depcom_init == "06959" & toupper(ps$libcom_init) %in% c("PLASCASSIER", ""),
                      "06069",as.character(ps$depcom)
  ) # PLASCASSIER : 06959-->06069
  
  ps$depcom <- ifelse(ps$depcom_init == "12936" & toupper(ps$libcom_init) %in% c("GAGES", ""),
                      "12157", as.character(ps$depcom)
  ) # GAGES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "12937" & toupper(ps$libcom_init) %in% c("LA PRIMAUBE", ""),
                      "12133",
                      as.character(ps$depcom)
  ) # LA PRIMAUBE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "12937" & toupper(ps$libcom_init) %in% c("LUC LA PRIMAUBE", ""),
                      "12133", as.character(ps$depcom)
  ) # LUC LA PRIMAUBE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "13140" & toupper(ps$libcom_init) %in% c("TOURVES"),
                      "83140", as.character(ps$depcom)
  ) # TOURVES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "13902" & toupper(ps$libcom_init) %in% c("LUYNES"),
                      "13001", as.character(ps$depcom)
  ) # LUYNES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A201" & toupper(ps$libcom_init) %in% c("SARTENE", ""),
                      "2A272", as.character(ps$depcom)
  ) # : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A902" & toupper(ps$libcom_init) %in% c("PORTO", ""),
                      "2A198", as.character(ps$depcom)
  ) # PORTO : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A903" & toupper(ps$libcom_init) %in% c("PORTICCIO", ""),
                      "2A130", as.character(ps$depcom)
  ) # PORTICCIO : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A904" & toupper(ps$libcom_init) %in% c("MEZZAVIA", ""),
                      "2A004", as.character(ps$depcom)
  ) # MEZZAVIA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A904" & toupper(ps$libcom_init) %in% c("PLAINE DE PERI", ""),
                      "2A209", as.character(ps$depcom)
  ) # PLAINE DE PERI : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A905" & toupper(ps$libcom_init) %in% c("SOLENZARA", ""),
                      "2A269", as.character(ps$depcom)
  ) # SOLENZARA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A922" & toupper(ps$libcom_init) %in% c("ST LUCIE DE PORTO VECCHIO", "STE LUCIE DE PORTO VECCHI", ""),
                      "2A247", as.character(ps$depcom)
  ) # STE LUCIE DE PORTO VECCHIO : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2A934" & toupper(ps$libcom_init) %in% c("SAGONE", ""),
                      "2A348", as.character(ps$depcom)
  ) # SAGONE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B920" & toupper(ps$libcom_init) %in% c("MACINAGGIO", ""),
                      "2B261", as.character(ps$depcom)) # MACINAGGIO : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B923" & toupper(ps$libcom_init) %in% c("ERBALUNGA", ""),
                      "2B043", as.character(ps$depcom)
  ) # ERBALUNGA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B939" & toupper(ps$libcom_init) %in% c("SAN GIULIANO", ""),
                      "2B303", as.character(ps$depcom)
  ) # SAN GIULIANO : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B942" & toupper(ps$libcom_init) %in% c("BARCHETTA", ""),
                      "2B355", as.character(ps$depcom)
  ) # BARCHETTA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B947" & toupper(ps$libcom_init) %in% c("BIGUGLIA", ""),
                      "2B037", as.character(ps$depcom)
  ) # BIGUGLIA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B950" & toupper(ps$libcom_init) %in% c("PENTA DI CASINCA", ""),
                      "2B207", as.character(ps$depcom)
  ) # PENTA DI CASINCA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B955" & toupper(ps$libcom_init) %in% c("SANTA MARIA DI LOTA", ""),
                      "2B309", as.character(ps$depcom)
  ) # SANTA MARIA DI LOTA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B963" & toupper(ps$libcom_init) %in% c("PENTA DI CASINCA", ""),
                      "2B207", as.character(ps$depcom)
  ) # PENTA DI CASINCA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "2B959" & toupper(ps$libcom_init) %in% c("PIETRANERA", ""),
                      "2B305", 
                      as.character(ps$depcom)
  ) # PIETRANERA : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "30900" & toupper(ps$libcom_init) %in% c("NIMES", ""),
                      "30189", as.character(ps$depcom)
  ) # NIMES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "34926" & toupper(ps$libcom_init) %in% c("CARNON PLAGE", ""),
                      "34154", as.character(ps$depcom)
  ) # CARNON PLAGE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38905" & toupper(ps$libcom_init) %in% c("URIAGE", "URIAGE LES BAINS", ""),
                      "38422",as.character(ps$depcom)
  ) # URIAGE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38920" & toupper(ps$libcom_init) %in% c("BRIGNOUD", ""),
                      "38547", as.character(ps$depcom)
  ) # BRIGNOUD : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38925" & toupper(ps$libcom_init) %in% c("LES ADRETS", ""),
                      "38002", as.character(ps$depcom)
  ) # LES ADRETS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38928" & toupper(ps$libcom_init) %in% c("ALPE D HUEZ", "L ALPE D HUEZ", ""),
                      "38191", as.character(ps$depcom)
  ) # ALPE D HUEZ : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38930" & toupper(ps$libcom_init) %in% c("VILLARD BONNOT", "LANCEY", ""),
                      "38547", as.character(ps$depcom)
  ) # VILLARD BONNOT, LANCEY : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38931" & toupper(ps$libcom_init) %in% c("LES DEUX ALPES", "LESDEUXALPES"),
                      "38253", as.character(ps$depcom)
  ) # LES DEUX ALPES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "38932" & toupper(ps$libcom_init) %in% c("RIOUPEROUX", ""),
                      "38212", as.character(ps$depcom)
  ) # RIOUPEROUX : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "43329" & toupper(ps$libcom_init) %in% c("VENDRES", ""),
                      "34329", as.character(ps$depcom)
  ) # VENDRES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "43999" & toupper(ps$libcom_init) %in% c("BRIOUDE", ""),
                      "43040", as.character(ps$depcom)
  ) # BRIOUDE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "44905" & toupper(ps$libcom_init) %in% c("BASSE INDRE ", ""),
                      "44074", as.character(ps$depcom)
  ) # BASSE INDRE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "57902" & toupper(ps$libcom_init) %in% c("PETIT EBERSVILLER", ""),
                      "57428", as.character(ps$depcom)
  ) # : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "67912" & toupper(ps$libcom_init) %in% c("HARTHOUSE", ""),
                      "67180", as.character(ps$depcom)
  ) # HARTHOUSE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "67914" & toupper(ps$libcom_init) %in% c("HERSBACH", ""),
                      "67543", as.character(ps$depcom)
  ) # HERSBACH : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "67948" & toupper(ps$libcom_init) %in% c("MARIENTHAL", ""),
                      "67230",
                      as.character(ps$depcom)
  ) # MARIENTHAL : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "67949" & toupper(ps$libcom_init) %in% c("LA CLAQUETTE", ""),
                      "67066", as.character(ps$depcom)
  ) # LA CLAQUETTE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "62913" & toupper(ps$libcom_init) %in% c("BLERIOT-PLAGE", "BLERIOT PLAGE", ""),
                      "62774", as.character(ps$depcom)
  ) # BLERIOT-PLAGE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73901" & toupper(ps$libcom_init) %in% c("MÂCOT-LA-PLAGNE", ""),
                      "73150", as.character(ps$depcom)
  ) # MÂCOT-LA-PLAGNE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) %in% c("COURCHEVEL", "COURCHEVEL CEDEX", ""),
                      "73227", as.character(ps$depcom)
  ) # COURCHEVEL : -->")
  ps$depcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) %in% c("SAINT BON TARENTAISE", ""),
                      "73227", as.character(ps$depcom)
  ) # : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73923" & toupper(ps$libcom_init) %in% c("MERIBEL LES ALLUES", ""),
                      "73015", as.character(ps$depcom)
  ) # MERIBEL LES ALLUES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73924" & toupper(ps$libcom_init) %in% c("FONTCOUVERT-LA-TOUSSUINE", ""),
                      "73116", as.character(ps$depcom)
  ) # FONTCOUVERT-LA-TOUSSUINE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73927" & toupper(ps$libcom_init) %in% c("LES MENUIRES", ""),
                      "73257", as.character(ps$depcom)
  ) # LES MENUIRES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73925" & toupper(ps$libcom_init) %in% c("LE CORBIER", ""),
                      "73318", as.character(ps$depcom)
  ) # LE CORBIER : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "73928" & toupper(ps$libcom_init) %in% c("VAL THORENS", ""),
                      "73257", as.character(ps$depcom)
  ) # VAL THORENS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "74923" & toupper(ps$libcom_init) %in% c("SAINT GERVAIS LES BAINS", ""),
                      "74236", as.character(ps$depcom)
  ) # SAINT GERVAIS LES BAINS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "74926" & toupper(ps$libcom_init) %in% c("VIEUGY", ""),
                      "74300", as.character(ps$depcom)
  ) # VIEUGY : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "74950" & toupper(ps$libcom_init) %in% c("MORZINE", ""),
                      "74191", as.character(ps$depcom)
  ) # MORZINE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "75046" & toupper(ps$libcom_init) %in% c("MALAKOFF"),
                      "92046", as.character(ps$depcom)) # MALAKOFF : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "78025" & toupper(ps$libcom_init) %in% c("COLOMBES"),
                      "92025", as.character(ps$depcom)
  ) # COLOMBES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "78065" & toupper(ps$libcom_init) %in% c("CHAMBERY"),
                      "73065", as.character(ps$depcom)
  ) # CHAMBERY : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83900" & toupper(ps$libcom_init) %in% c("PORT GRIMAUD", ""),
                      "83068", as.character(ps$depcom)
  ) # PORT GRIMAUD : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83902" & toupper(ps$libcom_init) %in% c("LES SABLETTES", ""),
                      "83126", as.character(ps$depcom)
  ) # LES SABLETTES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83916" & toupper(ps$libcom_init) %in% c("BOULOURIS", ""),
                      "83118",as.character(ps$depcom)
  ) # BOULOURIS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83919" & toupper(ps$libcom_init) %in% c("LA MOUTONNE", "LA CRAU ","LA CRAU", ""),
                      "83047", as.character(ps$depcom)
  ) # LA MOUTONNE, LA CRAU : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83920" & toupper(ps$libcom_init) %in% c("AGAY", ""),
                      "83118", as.character(ps$depcom)
  ) # : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83921" & toupper(ps$libcom_init) %in% c("LE BRUSC", "SIX FOURS LES PLAGES ", "SIX FOURS LES PLAGES", ""),
                      "83129", as.character(ps$depcom)
  ) # LE BRUSC, SIX FOURS LES PLAGES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83922" & toupper(ps$libcom_init) %in% c( "GIENS", "HYERES", ""),
                      "83069", as.character(ps$depcom)
  ) # GIENS, HYERES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83923" & toupper(ps$libcom_init) %in% c("LES ISSAMBRES", ""),
                      "83107", as.character(ps$depcom)
  ) # LES ISSAMBRES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83924" & toupper(ps$libcom_init) %in% c( "PORQUEROLLES", ""),
                      "83069", as.character(ps$depcom)
  ) # PORQUEROLLES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83925" & toupper(ps$libcom_init) %in% c("SAINT AYGULF", ""),
                      "83061", as.character(ps$depcom)
  ) # SAINT AYGULF : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83926" & toupper(ps$libcom_init) %in% c("LES SALINS D'HYERES", ""),
                      "83069", as.character(ps$depcom)
  ) # LES SALINS D'HYERES : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "83935" & toupper(ps$libcom_init) %in% c( "LA CAPTE", ""),
                      "83069", as.character(ps$depcom)
  ) # LA CAPTE : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "84220" & toupper(ps$libcom_init) %in% c("NYONS", ""),
                      "26220", as.character(ps$depcom)
  ) # NYONS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "84922" & toupper(ps$libcom_init) %in% c("MONTFAVET", ""),
                      "84007", as.character(ps$depcom)
  ) # MONTFAVET : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "92056" & toupper(ps$libcom_init) %in% c("PARIS", ""),
                      "75056", as.character(ps$depcom)
  ) # PARIS : 92056-->75056
  
  ps$depcom <- ifelse(ps$depcom_init == "93119" & toupper(ps$libcom_init) %in% c("NOISY LE SEC", ""),
                      "93053", as.character(ps$depcom)
  ) # NOISY LE SEC : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "95175" & toupper(ps$libcom_init) %in% c("CORMEILLES EN PARISIS", ""),
                      "95176",as.character(ps$depcom)
  ) # CORMEILLES EN PARISIS : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "97300" & toupper(ps$libcom_init) %in% c("PLEAUX"),
                      "15153",as.character(ps$depcom)
  ) # PLEAUX : -->")
  
  ps$depcom <- ifelse(ps$depcom_init == "97622" & toupper(ps$libcom_init) == "DZAOUDZI",
                      "97608", as.character(ps$depcom)
  ) # DZAOUDZI: 97622 --> 97608
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "PAMANDZI",
                      "97615", as.character(ps$depcom)
  ) # PAMANDZI : 97976 --> 97615
  
  ps$depcom <- ifelse(ps$depcom_init == "97476" & toupper(ps$libcom_init) == "MAMOUDZOU",
                      "97611", as.character(ps$depcom)
  ) # MAMOUDZOU: 97476 --> 97611
  
  # Ajout pour correction 2019 
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "MAYOTTE",
                      "97611", as.character(ps$depcom)
  ) # Mayotte sans précision rattaché à Mamoudzou
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "MAMOUDZOU",
                      "97611", as.character(ps$depcom)
  ) # MAMOUDZOU : 97976 --> 97611
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "DZOUMOGNE",
                      "97602", as.character(ps$depcom)
  ) # DZOUMOGNE : 97976-->97602
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "DEMBENI",
                      "97607", as.character(ps$depcom)
  ) # DEMBENI : 97676-->97607
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "DEMBENI",
                      "97607", as.character(ps$depcom)
  ) # DEMBENI : 97976-->97607
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "CHICONI",
                      "97605", as.character(ps$depcom)
  ) # CHICONI : 97676-->97605
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "BANDRELE",
                      "97603", as.character(ps$depcom)
  ) # BANDRELE : 97676-->97603
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "BANDRELE",
                      "97603", as.character(ps$depcom)
  ) # BANDRELE : 97976-->97603
  
  ps$depcom <- ifelse(ps$depcom_init == "97976" & toupper(ps$libcom_init) == "LABATTOIR",
                      "97608", as.character(ps$depcom)
  ) # LABATTOIR : 97976-->97608
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "DZOUMOGNE",
                      "97602", as.character(ps$depcom)
  ) # DZOUMOGNE : 97676-->97602
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "HAMOURO",
                      "97603", as.character(ps$depcom)
  ) # HAMOURO : 97676-->97603
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "MTSANGAMOUJI",
                      "97613", as.character(ps$depcom)
  ) # MTSANGAMOUJI : 97676-->97613
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "MZOUAZIA",
                      "97604", as.character(ps$depcom)
  ) # MZOUAZIA : 97676-->97604
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "PASSAMAINTY",
                      "97611", as.character(ps$depcom)
  ) # PASSAMAINTY : 97676-->97611
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "LABATTOIR",
                      "97608", as.character(ps$depcom)
  ) # LABATTOIR : 97676-->97608
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "COMBANI",
                      "97617", as.character(ps$depcom)
  ) # COMBANI : 97676-->97617
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "KAWENI",
                      "97611", as.character(ps$depcom)
  ) # KAWENI : 97676-->97611
  
  ps$depcom <- ifelse(ps$depcom_init == "97506",
                      "97606", as.character(ps$depcom)
  ) # 97506-->97606
  
  ps$depcom <- ifelse(ps$depcom_init == "97510",
                      "97610", as.character(ps$depcom)
  ) # 97510-->97610
  
  ps$depcom <- ifelse(ps$depcom_init == "97511",
                      "97611", as.character(ps$depcom)
  ) # 97511-->97611
  
  ps$depcom <- ifelse(ps$depcom_init == "97516",
                      "97616", as.character(ps$depcom)
  ) # 97516-->97616
  
  ps$depcom <- ifelse(ps$depcom_init == "97522",
                      "97608", as.character(ps$depcom)
  ) # 97522-->97608
  
  ps$depcom <- ifelse(ps$depcom_init == "97660",
                      "97607", as.character(ps$depcom)
  ) # 97660-->97607
  
  # 11/04/2017 : Corrections des codes communes pour les MK (2015, dates de flux)
  
  ps$depcom <- ifelse(ps$depcom_init == "05202" & toupper(ps$libcom_init) == "STE FOY LES LYON",
                      "69202", as.character(ps$depcom)
  ) # STE FOY LES LYON : 05202-->69202
  
  ps$depcom <- ifelse(ps$depcom_init == "05206" & toupper(ps$libcom_init) == "ST AVE",
                      "56206", as.character(ps$depcom)
  ) # ST AVE : 05206-->56206
  
  ps$depcom <- ifelse(ps$depcom_init == "13123" & toupper(ps$libcom_init) == "SANARY",
                      "83123", as.character(ps$depcom)
  ) # SANARY : 13123-->83123
  
  ps$depcom <- ifelse(ps$depcom_init == "13172" & toupper(ps$libcom_init) == "CONFLANS SAINTE HONORINE",
                      "78172", as.character(ps$depcom)
  ) # CONFLANS SAINTE HONORINE : 13172-->78172
  
  ps$depcom <- ifelse(ps$depcom_init == "13231" & toupper(ps$libcom_init) == "TROIS ILETS",
                      "97231", as.character(ps$depcom)
  ) # TROIS ILETS : 13231-->97231
  
  ps$depcom <- ifelse(ps$depcom_init == "22574" & toupper(ps$libcom_init) == "ST PRIX",
                      "78574", as.character(ps$depcom)
  ) # ST PRIX : 22574-->78574
  
  ps$libcom <- ifelse(ps$depcom_init == "97127" & toupper(ps$libcom_init) == "SAINT- MARTIN",
                      "SAINT MARTIN", as.character(ps$libcom)
  ) # SAINT- MARTIN --> SAINT MARTIN")
  
  ps$depcom <- ifelse(ps$depcom_init == "97349" & toupper(ps$libcom_init) == "ST MEDARD EN JALLES",
                      "33449", as.character(ps$depcom)
  ) # ST MEDARD EN JALLES : 97349-->33449
  
  ps$libcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "TSOUNDZOU 2",
                      "MAMOUDZOU", as.character(ps$libcom)
  ) # TSOUNDZOU 2 --> MAMOUDZOU")
  
  # Corrections 30/01/2017 (sf)
  
  ps$depcom <- ifelse(ps$depcom_init == "01902" & toupper(ps$libcom_init) == "MONTREAL LA CLUSE",
                      "01265", as.character(ps$depcom)
  ) # MONTREAL LA CLUSE : 01902-->01265
  
  ps$depcom <- ifelse(ps$depcom_init == "05318" & toupper(ps$libcom_init) == "MONTPONT EN BRESSE",
                      "71318",as.character(ps$depcom)
  ) # MONTPONT EN BRESSE : 05318-->71318
  
  ps$depcom <- ifelse(ps$depcom_init == "38920" & toupper(ps$libcom_init) == "VILLARD BONNOT",
                      "38547",
                      as.character(ps$depcom)
  ) # VILLARD BONNOT : 38920-->38547
  
  ps$depcom <- ifelse(ps$depcom_init == "65650" & toupper(ps$libcom_init) == "VIC EN BIGORRE",
                      "65460",as.character(ps$depcom)
  ) # VIC EN BIGORRE : 65650-->65460
  
  # Corrections 23/03/2017 (sf 2016)
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "MAJICAVO 1",
                      "97610", as.character(ps$depcom)
  ) # MAJICAVO 1 : 97676-->97610
  
  ps$depcom <- ifelse(ps$depcom_init == "13273" & toupper(ps$libcom_init) == "PERIGNAC",
                      "17273", as.character(ps$depcom)
  ) # PERIGNAC : 13273-->17273
  
  # Corrections faites pour MG 2011
  
  ps$depcom <- ifelse(ps$depcom_init == "13143" & toupper(ps$libcom_init) %in% c("SAINT GENIS", ""),
                      "05143", as.character(ps$depcom)
  ) # SAINT GENIS : 13143-->05143
  
  ps$depcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) == "COURCHEVEL  1850",
                      "73227", as.character(ps$depcom)
  ) # COURCHEVEL  1850 : 73920-->73227
  
  # Corrections faites pour MG 2014
  
  ps$depcom <- ifelse(ps$depcom_init == "63638" & toupper(ps$libcom_init) == "SAINT JULIEN DE COPPEL",
                      "63368", as.character(ps$depcom)
  ) # SAINT JULIEN DE COPPEL : 63638-->63368
  
  ps$depcom <- ifelse(ps$depcom_init == "83912" & toupper(ps$libcom_init) == "LES LECQUES",
                      "83112", as.character(ps$depcom)
  ) # LES LECQUES : 83912-->83112
  
  # 31/08/2017
  
  ps$depcom <- ifelse(ps$depcom_init == "2A904" & toupper(ps$libcom_init) %in% c("MEZAVIA", ""),
                      "2A004", as.character(ps$depcom)
  ) # MEZAVIA : 2A904-->2A004
  
  ps$depcom <- ifelse(ps$depcom_init == "2A903" & toupper(ps$libcom_init) %in% c("MOLINI", ""),
                      "2A130", as.character(ps$depcom)
  ) # MOLINI : 2A903-->2A130
  
  ps$depcom <- ifelse(ps$depcom_init == "2A930" & toupper(ps$libcom_init) %in% c("PORTICCIO", ""),
                      "2A130", as.character(ps$depcom)
  ) # PORTICCIO : 2A930-->2A130
  
  # Corrections faites pour spé 2016
  
  ps$depcom <- ifelse(ps$depcom_init == "75571" & toupper(ps$libcom_init) == "PARIS CEDEX 12",
                      "75112",as.character(ps$depcom)
  ) # PARIS CEDEX 12 : 75571-->75112
  
  ps$depcom <- ifelse(ps$depcom_init == "84922" & toupper(ps$libcom_init) == "AVIGNON CEDEX 9",
                      "84007", as.character(ps$depcom)
  ) # AVIGNON CEDEX 9 : 84922-->84007
  
  ps$depcom <- ifelse(ps$depcom_init == "35513" & toupper(ps$libcom_init) == "CESSON SEVIGNE",
                      "35051", as.character(ps$depcom)
  ) # CESSON SEVIGNE : 35513-->35051
  
  # FOB 06/09/2017 : Corrections pour les infirmiers DS 2016
  
  ps$depcom <- ifelse(ps$depcom_init == "13173" & toupper(ps$libcom_init) == "PALUDS DE NOVES",
                      "13066", as.character(ps$depcom)
  ) # PALUDS DE NOVES : 13173-->13066
  
  ps$depcom <- ifelse(ps$depcom_init == "94901" & toupper(ps$libcom_init) == "LA VARENNE SAINT HILAIRE",
                      "94068", as.character(ps$depcom)
  ) # LA VARENNE SAINT HILAIRE : 94901-->94068
  
  # AJOUT 20/04/2021
  
  ps$depcom <- ifelse(ps$depcom_init == "13055" & toupper(ps$libcom_init) == "PORT DE BOUC",
                      "13077", as.character(ps$depcom)
  ) 
  
  # 01/02/2018 - MG 2015 
  
  ps$depcom <- ifelse(ps$depcom_init == "13139" & toupper(ps$libcom_init) == "LUYNES",
                      "13001", as.character(ps$depcom)
  ) # LUYNES : 13139-->13001
  
  
  ps$depcom <- ifelse(ps$depcom_init == "84172" & toupper(ps$libcom_init) == "MONTPELLIER",
                      "84035", as.character(ps$depcom)
  ) # MONTPELLIER : 84172 --> CAVAILLON : 84035
  
  ps$libcom <- ifelse(ps$depcom_init == "84172" & toupper(ps$libcom_init) == "MONTPELLIER",
                      "CAVAILLON", as.character(ps$libcom)
  ) # MONTPELLIER : 84172 --> CAVAILLON : 84035
  
  # 27/03/2018: Corrections pour les kinés DS 2016
  
  ps$depcom <- ifelse(ps$depcom_init == "05209" & toupper(ps$libcom_init) == "SISTERON",
                      "04209", as.character(ps$depcom)
  ) # SISTERON : 05209-->04209
  
  ps$depcom <- ifelse(ps$depcom_init == "05271" & toupper(ps$libcom_init) == "LANTA",
                      "31271", as.character(ps$depcom)
  ) # LANTA : 05271-->31271
  
  ps$depcom <- ifelse(ps$depcom_init == "13122" & toupper(ps$libcom_init) == "BIARRITZ",
                      "64122", as.character(ps$depcom)
  ) # BIARRITZ : 13122-->64122
  
  # 07/06/2018: Corrections pour le calcul APL MG2016 nouvelle méthode (nouvelle extraction)
  
  ps$depcom <- ifelse(ps$depcom_init == "97300" & toupper(ps$libcom_init) == "PLEAUX",
                      "15153", as.character(ps$depcom)
  ) # PLEAUX : 97300-->15153
  
  ps$depcom <- ifelse(ps$depcom_init == "81573" & toupper(ps$libcom_init) == "VERFEIL",
                      "31573", as.character(ps$depcom)
  ) # VERFEIL : 81573-->31573 #BL 21/12/2018
  
  ps$depcom <- ifelse(ps$depcom_init == "83907" & toupper(ps$libcom_init) == "ILE DE PORT CROS",
                      "83069", as.character(ps$depcom)
  ) # ILE DE PORT CROS : 83907 --> HYERES : 83069
  
  ps$libcom <- ifelse(ps$depcom_init == "83907" & toupper(ps$libcom_init) == "ILE DE PORT CROS",
                      "HYERES", as.character(ps$libcom)
  ) # ILE DE PORT CROS : 83907 --> HYERES : 83069
  
  # CA  17/07/2018: Corrections pour le calcul APL MK2017
  
  ps$depcom <- ifelse(ps$depcom_init == "06190" & toupper(ps$libcom_init) == "PLOUGONVELIN",
                      "29190", as.character(ps$depcom)
  ) # PLOUGONVELIN : 06190-->29190
  
  ps$depcom <- ifelse(ps$depcom_init == "06295" & toupper(ps$libcom_init) == "LES GRANGETTES",
                      "25295", as.character(ps$depcom)
  ) # LES GRANGETTES : 06295-->25295
  
  ps$depcom <- ifelse(ps$depcom_init == "11560" & toupper(ps$libcom_init) == "SAINT PIERRE LA MER",
                      "11145", as.character(ps$depcom)
  ) # SAINT PIERRE LA MER : 11560 --> FLEURY : 11145
  
  ps$libcom <- ifelse(ps$depcom_init == "11560" & toupper(ps$libcom_init) == "SAINT PIERRE LA MER",
                      "FLEURY", as.character(ps$libcom)
  ) # SAINT PIERRE LA MER : 11560 --> FLEURY : 11145
  
  ps$depcom <- ifelse(ps$depcom_init == "13928" & toupper(ps$libcom_init) == "ENTRESSEN",
                      "13047", as.character(ps$depcom)
  ) # ENTRESSEN : 13928 --> ISTRES : 13047
  
  ps$libcom <- ifelse(ps$depcom_init == "13928" & toupper(ps$libcom_init) == "ENTRESSEN",
                      "ISTRES", as.character(ps$libcom)
  ) # ENTRESSEN : 13928 --> ISTRES : 13047
  
  ps$depcom <- ifelse(ps$depcom_init == "97441" & toupper(ps$libcom_init) == "STE CLOTILDE",
                      "97411", as.character(ps$depcom)
  ) # STE CLOTILDE : 97441 --> ST DENIS : 97411
  
  ps$libcom <- ifelse(ps$depcom_init == "97441" & toupper(ps$libcom_init) == "STE CLOTILDE",
                      "ST DENIS", as.character(ps$libcom)
  ) # STE CLOTILDE : 97441 --> ST DENIS : 97411
  
  ps$depcom <- ifelse(ps$depcom_init == "44422" & toupper(ps$libcom_init) == "LE TAMPON",
                      "97422", as.character(ps$depcom)
  ) # LE TAMPON : 44422-->97422
  
  ps$depcom <- ifelse(ps$depcom_init == "67926" & toupper(ps$libcom_init) == "OBERMODERN ZUTZENDORF",
                      "67347", as.character(ps$depcom)
  ) # OBERMODERN ZUTZENDORF : 67926-->67347
  
  ps$depcom <- ifelse(ps$depcom_init == "83155" & toupper(ps$libcom_init) == "SAINTE MAXIME",
                      "83115", as.character(ps$depcom)
  ) # SAINTE MAXIME : 83155-->83115
  
  # 23/07/2018: Corrections pour le calcul APL SF2017
  
  ps$depcom <- ifelse(ps$depcom_init == "08512" & toupper(ps$libcom_init) == "BOGNY SUR MEUSE",
                      "08081", as.character(ps$depcom)
  ) # BOGNY SUR MEUSE : 08512-->08081
  
  ps$depcom <- ifelse(ps$depcom_init == "21901" & toupper(ps$libcom_init) == "LADOIX SERRIGNY",
                      "21606", as.character(ps$depcom)
  ) # LADOIX SERRIGNY : 21901-->21606
  
  ps$depcom <- ifelse(ps$depcom_init == "91118" & toupper(ps$libcom_init) == "LES ULIS",
                      "91692", as.character(ps$depcom)
  ) # LES ULIS : 91118-->91692
  
  # 13/09/2018: Corrections pour le calcul APL INF2017
  
  ps$depcom <- ifelse(ps$depcom_init == "30489" & toupper(ps$libcom_init) == "THAL MARMOUTIER",
                      "67489", as.character(ps$depcom)
  ) # THAL MARMOUTIER : 30489-->67489
  
  # 2018-09-11: corrections pour calcul APL-MG-2017
  
  ps$depcom <- ifelse(ps$depcom_init == "05207" & toupper(ps$libcom_init) == "DUCOS",
                      "97207", as.character(ps$depcom)
  ) # DUCOS : 05207-->97207 #coherent avec code postal dans la table "a_corriger" : 97224
  
  ps$depcom <- ifelse(ps$depcom_init == "33992" & toupper(ps$libcom_init) == "BOURDEILLES",
                      "24055", as.character(ps$depcom)
  ) # BOURDEILLES : 33992-->24055 # coherent avec code postal dans la table "a_corriger" : 24310
  
  ps$depcom <- ifelse(ps$depcom_init == "33999" & toupper(ps$libcom_init) == "LES ANSES D ARLET",
                      "97202", as.character(ps$depcom)
  ) # LES ANSES D ARLET : 33999-->97202 #coherent avec code postal dans la table "a_corriger" : 97217
  
  ps$depcom <- ifelse(ps$depcom_init == "33999" & toupper(ps$libcom_init) == "PARIS",
                      "75108", as.character(ps$depcom)
  ) # PARIS : 33999-->75008 #d'apres code postal dans la table "a_corriger"
  
  ps$depcom <- ifelse(ps$depcom_init == "44905" & toupper(ps$libcom_init) == "BASSE GOULAINE",
                      "44009", as.character(ps$depcom)
  ) # BASSE GOULAINE : 44905-->44009
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "TREVANI",
                      "97610", as.character(ps$depcom)
  ) # TREVANI : 97676-->97610 #https://fr.wikipedia.org/wiki/Koungou#Tr%C3%A9vani
  
  # 2019-04-01 : MG 2016, CDS, ancienne extraction
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "POTIGNY",
                      "14516", as.character(ps$depcom)
  ) # POTIGNY : -->14516
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "MONTPELLIER",
                      "34172", as.character(ps$depcom)
  ) # MONTPELLIER : -->34172
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "PAU",
                      "64445", as.character(ps$depcom)
  ) # PAU : -->64445
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "MICHELBACH-LE-BAS",
                      "68207", as.character(ps$depcom)
  ) # MICHELBACH-LE-BAS : -->68207
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "GRIGNY",
                      "69096", as.character(ps$depcom)
  ) # GRIGNY : -->69096
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "PARIS 18EME",
                      "75118", as.character(ps$depcom)
  ) # PARIS 18EME : -->75118
  
  ps$depcom <- ifelse(ps$depcom_init == "" & toupper(ps$libcom_init) == "PARIS 15EME",
                      "75115", as.character(ps$depcom)
  ) # PARIS 15EME : -->75115
  
  # 2019-04-23 : MG 2015, nouvelle extraction
  
  ps$depcom <- ifelse(ps$depcom_init == "37314" & toupper(ps$libcom_init) == "PAUILLAC",
                      "33314", as.character(ps$depcom)
  ) # PAUILLAC : 37314-->33314
  
  ps$depcom <- ifelse(ps$depcom_init == "74339" & toupper(ps$libcom_init) == "VESSEAUX",
                      "07339", as.character(ps$depcom)
  ) # VESSEAUX : 74339-->07339
  
  ps$depcom <- ifelse(ps$depcom_init == "84160" & toupper(ps$libcom_init) == "REILLANNE",
                      "04160", as.character(ps$depcom)
  ) # REILLANNE : 84160-->04160
  
  # 2019-09-12 : MG 2018 GEO 2019
  
  ps$depcom <- ifelse(ps$depcom_init == "13999" & toupper(ps$libcom_init) == "SAINT JEAN D AULPS",
                      "74238", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "95586" & toupper(ps$libcom_init) == "SARTROUVILLE",
                      "74238", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "PASSAMAINTI",
                      "97611", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "PASSAMAINTI",
                      "MAMOUDZOU", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97502" & toupper(ps$libcom_init) == "SAINT-PIERRE",
                      "97225", as.character(ps$depcom))
  
  # 2020-01-16 : MK 2018 GEO 2019
  
  ps$depcom <- ifelse(ps$depcom_init == "33999" & toupper(ps$libcom_init) == "LYON" & ps$codepost == "69002",
                      "69382", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "33999" & toupper(ps$libcom_init) == "LYON" & ps$codepost == "69007",
                      "69387", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "38583" & toupper(ps$libcom_init) == "ST ETIENNE DE CROSSEY",
                      "38383", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73923" & toupper(ps$libcom_init) == "LES ALLUES",
                      "73015", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "85600" & toupper(ps$libcom_init) == "MONTAIGU",
                      "85146", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "SADA MAYOTTE",
                      "97608", as.character(ps$depcom))
  
  # 2020-01-16 : INF 2018 GEO 2019
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "DZAOUDZI LABATTOIR",
                      "97616", as.character(ps$depcom))
  
  # 2020-07-06 : MG 2019 GEO 2020
  
  ps$depcom <- ifelse(ps$depcom_init == "05253" & toupper(ps$libcom_init) == "MONTOLIEU",
                      "11253", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "44232" & toupper(ps$libcom_init) == "QUIMPER",
                      "29232", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97460" & toupper(ps$libcom_init) == "ST PAUL",
                      "97415", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97432" & toupper(ps$libcom_init) == "RAVINE DES CABRIS", #lieu-dit quartier de st pierre
                      "97416", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97499" & toupper(ps$libcom_init) == "ST PIERRE CEDEX",
                      "97416", as.character(ps$depcom))
  
  # 2020-07-06 : INF 2019 GEO 2020
  
  ps$depcom <- ifelse(ps$depcom_init == "04999" & toupper(ps$libcom_init) == "VINON SUR VERDON",
                      "83150", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "05224" & toupper(ps$libcom_init) == "ST GENIEZ D'OLT ET D'AUBR",
                      "12224", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "06210" & toupper(ps$libcom_init) == "QUISSAC",
                      "30210", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "06924" & toupper(ps$libcom_init) == "JUAN LES PINS CEDEX",
                      "06004", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "2B405" & toupper(ps$libcom_init) == "ST SORLIN DE CONAC",
                      "17405", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "43383" & toupper(ps$libcom_init) == "LYON",
                      "69383", as.character(ps$depcom))
  
  # 2020-07-07 : SF 2019 GEO 2020
  
  ps$depcom <- ifelse(ps$depcom_init == "13920" & toupper(ps$libcom_init) == "LES MILLES",
                      "13001", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "2A903" & toupper(ps$libcom_init) == "MEZZAVIA",
                      "2A004", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "2B004" & toupper(ps$libcom_init) == "ANTIBES",
                      "06004", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "67947" & toupper(ps$libcom_init) == "KLINGENTHAL",
                      "67052", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "95319" & toupper(ps$libcom_init) == "L ISLE ADAM",
                      "95313", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "95552" & toupper(ps$libcom_init) == "FRANCONVILLE LA GARENNE",
                      "95252", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "MAMAOUDZOU",
                      "97611", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97680" & toupper(ps$libcom_init) == "COMBANI",
                      "97617", as.character(ps$depcom))
  
  # 01/03/21 : CD 2019, géo 2020
  
  ps$depcom <- ifelse(ps$depcom_init == "44904" & toupper(ps$libcom_init) == "THARON PLAGE",
                      "44182", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "44904" & toupper(ps$libcom_init) == "THARON PLAGE",
                      "ST MICHEL CHEF CHEF", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73926" & toupper(ps$libcom_init) == "LES ARCS 1600",
                      "73054", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "73926" & toupper(ps$libcom_init) == "LES ARCS 1600",
                      "BOURG ST MAURICE", as.character(ps$libcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97127" & toupper(ps$libcom_init) == "SAINT-MARTIN",
                      "SAINT MARTIN", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97400" & toupper(ps$libcom_init) == "ST DENIS",
                      "97411", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97425" & toupper(ps$libcom_init) == "LES AVIRONS",
                      "97401", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97430" & toupper(ps$libcom_init) == "LE TAMPON",
                      "97422", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97432" & toupper(ps$libcom_init) == "LA RAVINE DES CABRIS",
                      "97416", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97432" & toupper(ps$libcom_init) == "LA RAVINE DES CABRIS",
                      "ST PIERRE", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97434" & toupper(ps$libcom_init) == "LA SALINE LES BAINS",
                      "97415", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97434" & toupper(ps$libcom_init) == "LA SALINE LES BAINS",
                      "ST PAUL", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97436" & toupper(ps$libcom_init) == "ST LEU",
                      "97413", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97650" & toupper(ps$libcom_init) == "DZOUMOGNE",
                      "97602", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97650" & toupper(ps$libcom_init) == "DZOUMOGNE",
                      "BANDRABOUA", as.character(ps$libcom))
  
  # 18/05/2022 : Ajout étude téléconsultations des médecins généralistes 
  ps$depcom <- ifelse(ps$depcom_init == "06920" & toupper(ps$libcom_init) == "CANNESLABOCCA",
                      "06029", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "06920" & toupper(ps$libcom_init) == "CANNESLABOCCA",
                      "CANNES", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "12937" & toupper(ps$libcom_init) == "LAPRIMAUBE",
                      "12133", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "12937" & toupper(ps$libcom_init) == "LAPRIMAUBE",
                      "LUC-LA-PRIMAUBE", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "2A167" & toupper(ps$libcom_init) == "SARROLA-CARCOPINO",
                      "2A271", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "2A922" & toupper(ps$libcom_init) == "STELUCIEDEPORTOVECCHI",
                      "2A362", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "2A922" & toupper(ps$libcom_init) == "STELUCIEDEPORTOVECCHI",
                      "ZONZA", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73901" & toupper(ps$libcom_init) == "LAPLAGNETARENTAISE",
                      "73150", as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) == "COURCHEVELCEDEX",
                      "73227", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) == "COURCHEVELCEDEX",
                      "COURCHEVEL", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) == "SAINTBONTARENTAISE",
                      "73227", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "73920" & toupper(ps$libcom_init) == "SAINTBONTARENTAISE",
                      "COURCHEVEL", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "73923" & toupper(ps$libcom_init) == "MERIBELLESALLUES",
                      "73015", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "73923" & toupper(ps$libcom_init) == "MERIBELLESALLUES",
                      "LES ALLUES", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "83923" & toupper(ps$libcom_init) == "LESISSAMBRES",
                      "83107", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "83923" & toupper(ps$libcom_init) == "LESISSAMBRES",
                      "ROQUEBRUNE-SUR-ARGENS", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97432" & toupper(ps$libcom_init) == "RAVINEDESCABRIS",
                      "97416", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97432" & toupper(ps$libcom_init) == "RAVINEDESCABRIS",
                      "SAINT-PIERRE", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97460" & toupper(ps$libcom_init) == "STPAUL",
                      "97415", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97460" & toupper(ps$libcom_init) == "STPAUL",
                      "SAINT-PAUL", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "DZAOUDZILABATTOIR",
                      "97604", as.character(ps$depcom))
  
  ps$libcom <- ifelse(ps$depcom_init == "97676" & toupper(ps$libcom_init) == "DZAOUDZILABATTOIR",
                      "DZAOUDZI", as.character(ps$libcom))
  
  ps$depcom <- ifelse(ps$depcom_init == "99131" & toupper(ps$libcom_init) == "COMINES",
                      "59152", as.character(ps$depcom))
  
  ps[depcom_init == "97023",depcom := "97105"]
  ps[depcom_init == "97105" & is.na(libcom_init),libcom := "BASSETERRE"]
  
  ps$depcom <- ifelse(ps$depcom_init == "13133" & toupper(ps$libcom_init) == "MARSEILLE",
                      "13055", as.character(ps$depcom))
  
  # Paris-Lyon-Marseille : utilisation du code postal
  ps$depcom <- ifelse(ps$depcom == "75056" & ps$codepost %in% c(paste0(rep("7500", 9), 1:9), paste0(rep("750", 11), 10:20)),
                      gsub(ps$codepost, pattern = "750", replacement = "751"),
                      as.character(ps$depcom))
  ps$depcom <- ifelse(ps$depcom == "69123" & ps$codepost %in% c(paste0(rep("6900", 9), 1:9)),
                      gsub(ps$codepost, pattern = "6900", replacement = "6938"),
                      as.character(ps$depcom))
  ps$depcom <- ifelse(ps$depcom == "13055" & ps$codepost %in% c(paste0(rep("1300", 9), 1:9), paste0(rep("130", 7), 10:16)),
                      gsub(ps$codepost, pattern = "130", replacement = "132"),
                      as.character(ps$depcom))
  
  ps$depcom <- ifelse(ps$depcom %in% c(paste0(rep("7500", 9), 1:9), paste0(rep("750", 11), 10:20)) & (ps$codepost == ps$depcom | ps$libcom == "PARIS"),
                      gsub(ps$codepost, pattern = "750", replacement = "751"),
                      as.character(ps$depcom))
  ps$depcom <- ifelse(ps$depcom %in% c(paste0(rep("6900", 9), 1:9)) & (ps$codepost == ps$depcom | ps$libcom == "LYON"),
                      gsub(ps$codepost, pattern = "6900", replacement = "6938"),
                      as.character(ps$depcom))
  ps$depcom <- ifelse(ps$depcom %in% c(paste0(rep("1300", 9), 1:9), paste0(rep("130", 7), 10:16)) & (ps$codepost == ps$depcom | ps$libcom == "MARSEILLE"),
                      gsub(ps$codepost, pattern = "130", replacement = "132"),
                      as.character(ps$depcom))
  
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom,])," lignes"))
  
  ##### Saint-Martin, Saint-Pierre et Saint-Barthélémy #####
  
  print("Saint-Martin, Saint-Pierre, Saint-Barthélémy")
  
  ps <- ps[substr(ps$depcom,1,2)%in%c("97","9A") & substr(ps$depcom,1,3)!="974" & toupper(ps$libcom) %in% c(
    "SAINT MARTIN",
    "ST MARTIN",
    "ST MARTIN CEDEX",
    "SAINT BARTHELEMY",
    "ST BARTHELEMY",
    "SAINT BARTHELEMY CEDEX",
    "SAINT-PIERRE",
    "SAINTMARTIN",
    "STMARTIN",
    "SAINTPIERRE",
    "STPIERRE",
    "SAINTBARTHELEMY",
    "STBARTHELEMY"
  ),depcom:=NA]
  
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom,])," lignes"))
  
  ps[substr(depcom,1,2)=="98" | (substr(depcom,1,2)=="99" & substr(libcom,1,2)=="B-"),depcom:=NA]
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom,])," lignes"))
  
  ps <- ps[,-c("depcom_init","libcom_init")]
  
  ##### Correction par le libellé de la commune et le département #####
  
  print("Correction par le libellé de la commune et le département")
  
  setnames(communes2022,"depcom","depcom_geo")
  
  ps <- merge(ps,communes2022,
              by.x = c("dep","libcom"),
              by.y = c("dep","libcom_geo"),all.x = T)
  
  ps[!depcom%in%communes2022$depcom_geo & !is.na(depcom_geo) & depcom!=depcom_geo,depcom := depcom_geo]
  
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom_geo,])," lignes"))
  
  ##### Correction par l'historique des changements de commune #####
  
  print("Correction par l'historique des changements de commune")
  
  ps <- ps[,-c("depcom_geo")]
  
  setnames(mvtcommune2022,"depcom","depcom_nouv")
  mvtcommune2022[,depcom_anc := as.character(depcom_anc)]
  mvtcommune2022[,depcom_nouv := as.character(depcom_nouv)]
  
  mvtcommune2022[nchar(depcom_anc) == 4,depcom_anc := paste0("0",depcom_anc)]
  mvtcommune2022[nchar(depcom_nouv) == 4,depcom_nouv := paste0("0",depcom_nouv)]
  
  ps <- merge(ps,mvtcommune2022,by.x = "depcom",by.y = "depcom_anc",all.x = T)
  
  ps[!depcom%in%communes2022$depcom_geo & !is.na(depcom_nouv),depcom := depcom_nouv]
  
  print(paste0("Codes communes incorrects :",nrow(ps[!depcom%in%communes2022$depcom_geo,])," lignes"))
  
  ps <- ps[,-c("depcom_nouv")]
  
  setnames(communes2022,"depcom_geo","depcom")
  setnames(mvtcommune2022,"depcom_nouv","depcom")
  
  print("Codes communes incorrects restants")
  print(unique(ps[!depcom%in%communes2022$depcom,depcom]))
  
  ps[!depcom%in%communes2022$depcom,depcom := NA]
}
